//importing React and some hooks from react
import React, { useState, useEffect } from 'react';
//importing the function json() from D3
import { json } from 'd3';
//importing the functions feature() and mesh() from TopoJSON
import { feature, mesh } from 'topojson';

//Specifing the link to access the  file containing the geographic information of the states in the USA.
const jsonUrl = 'https://unpkg.com/us-atlas@3.0.0/states-10m.json';
//useData() in React is an local store to share data across components based on hooks
export const useData = () => {
  const [data, setData] = useState(null);

// function useEffect() lets us perform side effects in function components
  useEffect(() => {
    json(jsonUrl).then(topology => {
//assigning the ojects to 'states' constant
      const { states } = topology.objects;
      setData({
        land: feature(topology, states),
        interiors: mesh(topology, states, (a, b) => a !== b)
      });
    });
  }, []);
//returnd the map
 return data;
};
